Index: branches/2013/dev_r3940_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90
===================================================================
--- branches/2013/dev_r3940_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 4015)
+++ branches/2013/dev_r3940_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 4064)
@@ -51,4 +51,6 @@
    END INTERFACE
 
+   REAL(wp) :: r_inf = 1e+36
+
    !! Substitutions
 #  include "domzgr_substitute.h90"
@@ -60,5 +62,5 @@
       
       INTEGER  ::  ji, jj, jk                   ! dummy loop indices
-      INTEGER  ::  ijie,ijis,ijje,ijjs
+      INTEGER  ::  ijie,ijis,ijje,ijjs,ij,je_2
       REAL(wp) ::  zmask
       
@@ -69,13 +71,39 @@
       umask_crs(:,:,:) = 0.0
       fmask_crs(:,:,:) = 0.0
-      
+  
+            
+      IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+         IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
+            je_2 = mje_crs(2)   ;  ij = je_2
+         ENDIF
+      ELSE
+         je_2 = mje_crs(2)      ;  ij = mjs_crs(2) 
+      ENDIF
       DO jk = 1, jpkm1
          DO ji = 2, nlei_crs  
-            ijie = mie_crs(ji)
-            ijis = mis_crs(ji)
-            DO jj = nldj_crs, nlej_crs 
-               ijje = mje_crs(jj) 
-               ijjs = mjs_crs(jj) 
-                                 
+            ijis = mis_crs(ji)  ;  ijie = mie_crs(ji)    
+            !          
+            zmask = 0.0
+            zmask = SUM( tmask(ijis:ijie,ij:je_2,jk) ) 
+            IF ( zmask > 0.0 ) tmask_crs(ji,2,jk) = 1.0
+               
+            zmask = 0.0
+            zmask = SUM( vmask(ijis:ijie,je_2     ,jk) )  
+            IF ( zmask > 0.0 ) vmask_crs(ji,2,jk) = 1.0
+               
+            zmask = 0.0
+            zmask = SUM(umask(ijie,ij:je_2,jk))   
+            IF ( zmask > 0.0 ) umask_crs(ji,2,jk) = 1.0
+               
+            fmask_crs(ji,je_2,jk) = fmask(ijie,2,jk)
+         ENDDO
+      ENDDO
+      !
+      DO jk = 1, jpkm1
+         DO ji = 2, nlei_crs  
+            ijis = mis_crs(ji)     ;   ijie = mie_crs(ji)       
+            DO jj = 3, nlej_crs
+               ijjs = mjs_crs(jj)  ;   ijje = mje_crs(jj)
+                          
                zmask = 0.0
                zmask = SUM( tmask(ijis:ijie,ijjs:ijje,jk) ) 
@@ -91,8 +119,8 @@
                
                fmask_crs(ji,jj,jk) = fmask(ijie,ijje,jk)  
-
             ENDDO
          ENDDO
       ENDDO
+
       !
       CALL crs_lbc_lnk( tmask_crs, 'T', 1.0 )
@@ -195,12 +223,5 @@
             ENDDO
       END SELECT
-
-      !                                             ! Fill i=1, i=jpi at j=1
-      p_gphi_crs(1      ,1) = p_gphi(jpi_crsm1,1)
-      p_glam_crs(1      ,1) = p_glam(jpi_crsm1,1)
-      !                                             ! Fill upper-right corner i=1, j=jpj_crs
-      p_gphi_crs(jpi_crs,1) = p_gphi(2        ,1)
-      p_glam_crs(jpi_crs,1) = p_glam(2        ,1)
-      !                                            
+      !
    END SUBROUTINE crs_dom_coordinates
 
@@ -233,5 +254,5 @@
       !! Local variables
       INTEGER :: ji, jj, jk     ! dummy loop indices
-      INTEGER :: ijie,ijis,ijje,ijjs,ijrs
+      INTEGER :: ijie,ijje,ijrs
   
       !!----------------------------------------------------------------  
@@ -241,9 +262,6 @@
          DO ji = 2, nlei_crs
             ijie = mie_crs(ji)
-            ijis = mis_crs(ji)
             DO jj = nldj_crs, nlej_crs
-               ijje = mje_crs(jj) 
-               ijjs = mjs_crs(jj)                   
-               ijrs =  mje_crs(jj) - mjs_crs(jj)
+               ijje = mje_crs(jj)   ;   ijrs =  mje_crs(jj) - mjs_crs(jj)
                ! Only for a factro 3 coarsening
                SELECT CASE ( cd_type )
@@ -335,11 +353,13 @@
       !! Local variables
       REAL(wp)                                :: zdAm
-      INTEGER                                 :: ji, jj, jk       ! dummy loop indices
-      INTEGER                                 :: ii, ij, ijie,ijje
-
-      REAL(wp), DIMENSION(:,:,:), POINTER     :: zvol      
+      INTEGER                                 :: ji, jj, jk , ii, ij, je_2
+
+      REAL(wp), DIMENSION(:,:,:), POINTER     :: zvol, zmask      
       !!----------------------------------------------------------------  
    
-      CALL wrk_alloc( jpi, jpj, jpk, zvol )
+      CALL wrk_alloc( jpi, jpj, jpk, zvol, zmask )
+
+      p_fld1_crs(:,:,:) = 0.0
+      p_fld2_crs(:,:,:) = 0.0
 
       DO jk = 1, jpk
@@ -347,102 +367,91 @@
       ENDDO
 
+      zmask(:,:,:) = 0.0
+      IF( cd_type == 'W' ) THEN
+         zmask(:,:,1) = p_mask(:,:,1) 
+         DO jk = 2, jpk
+            zmask(:,:,jk) = p_mask(:,:,jk-1) 
+         ENDDO
+      ELSE
+         DO jk = 1, jpk
+             zmask(:,:,jk) = p_mask(:,:,jk) 
+         ENDDO
+      ENDIF
+
+      IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+         IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
+            je_2 = mje_crs(2)
+            DO jk = 1, jpk           
+               DO ji = nistr, niend, nn_factx
+                  ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
+                  p_fld1_crs(ii,2,jk) =  zvol(ji,je_2  ,jk) + zvol(ji+1,je_2  ,jk) + zvol(ji+2,je_2  ,jk)  &
+                     &                 + zvol(ji,je_2-1,jk) + zvol(ji+1,je_2-1,jk) + zvol(ji+2,je_2-1,jk) 
+                  !
+                  zdAm =  zvol(ji  ,je_2,jk) * zmask(ji  ,je_2,jk)  &
+                    &   + zvol(ji+1,je_2,jk) * zmask(ji+1,je_2,jk)  &
+                    &   + zvol(ji+2,je_2,jk) * zmask(ji+2,je_2,jk) 
+                  ! 
+                  p_fld2_crs(ii,2,jk) = zdAm / p_fld1_crs(ii,2,jk) 
+               ENDDO
+            ENDDO
+         ENDIF
+      ELSE
+         je_2 = mjs_crs(2)
+         DO jk = 1, jpk           
+            DO ji = nistr, niend, nn_factx
+               ii   = ( ji - mis_crs(2) ) * rfactx_r + 2    
+               p_fld1_crs(ii,2,jk) =  zvol(ji,je_2  ,jk) + zvol(ji+1,je_2  ,jk) + zvol(ji+2,je_2  ,jk)  &
+                   &                + zvol(ji,je_2+1,jk) + zvol(ji+1,je_2+1,jk) + zvol(ji+2,je_2+1,jk)  &
+                   &                + zvol(ji,je_2+2,jk) + zvol(ji+1,je_2+2,jk) + zvol(ji+2,je_2+2,jk)  
+              !
+               zdAm = zvol(ji  ,je_2  ,jk) * zmask(ji  ,je_2  ,jk)  &
+                 &  + zvol(ji+1,je_2  ,jk) * zmask(ji+1,je_2  ,jk)  &
+                 &  + zvol(ji+2,je_2  ,jk) * zmask(ji+2,je_2  ,jk)  &
+                 &  + zvol(ji  ,je_2+1,jk) * zmask(ji  ,je_2+1,jk)  &
+                 &  + zvol(ji+1,je_2+1,jk) * zmask(ji+1,je_2+1,jk)  &
+                 &  + zvol(ji+2,je_2+1,jk) * zmask(ji+2,je_2+1,jk)  &
+                 &  + zvol(ji  ,je_2+2,jk) * zmask(ji  ,je_2+2,jk)  &
+                 &  + zvol(ji+1,je_2+2,jk) * zmask(ji+1,je_2+2,jk)  &
+                 &  + zvol(ji+2,je_2+2,jk) * zmask(ji+2,je_2+2,jk)
+                 ! 
+                 p_fld2_crs(ii,2,jk) = zdAm / p_fld1_crs(ii,2,jk) 
+            ENDDO
+         ENDDO
+      ENDIF
+
       DO jk = 1, jpk           
-         DO ji = nistr, niend, nn_factx
-            DO jj   = njstr, njend, nn_facty
-               ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
-               ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-               ijje = mje_crs(ij)
-               ijie = mie_crs(ii)
+         DO jj  = njstr, njend, nn_facty
+            DO ji = nistr, niend, nn_factx
+               ii  = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
+               ij  = ( jj - njstr ) * rfacty_r + 3
                !
                p_fld1_crs(ii,ij,jk) =  zvol(ji,jj  ,jk) + zvol(ji+1,jj  ,jk) + zvol(ji+2,jj  ,jk)  &
                    &                 + zvol(ji,jj+1,jk) + zvol(ji+1,jj+1,jk) + zvol(ji+2,jj+1,jk)  &
-                   &                 + zvol(ji,jj+2,jk) + zvol(ji+1,jj+2,jk) + zvol(ji+2,jj+2,jk)  
+                   &                 + zvol(ji,jj+2,jk) + zvol(ji+1,jj+2,jk) + zvol(ji+2,jj+2,jk) 
+               !
+               zdAm =  zvol(ji  ,jj  ,jk) * zmask(ji  ,jj  ,jk)  &
+                 &   + zvol(ji+1,jj  ,jk) * zmask(ji+1,jj  ,jk)  &
+                 &   + zvol(ji+2,jj  ,jk) * zmask(ji+2,jj  ,jk)  &
+                 &   + zvol(ji  ,jj+1,jk) * zmask(ji  ,jj+1,jk)  &
+                 &   + zvol(ji+1,jj+1,jk) * zmask(ji+1,jj+1,jk)  &
+                 &   + zvol(ji+2,jj+1,jk) * zmask(ji+2,jj+1,jk)  &
+                 &   + zvol(ji  ,jj+2,jk) * zmask(ji  ,jj+2,jk)  &
+                 &   + zvol(ji+1,jj+2,jk) * zmask(ji+1,jj+2,jk)  &
+                 &   + zvol(ji+2,jj+2,jk) * zmask(ji+2,jj+2,jk)
+                 ! 
+                p_fld2_crs(ii,ij,jk) = zdAm / p_fld1_crs(ii,ij,jk) 
             ENDDO
          ENDDO
       ENDDO
-
-      IF( cd_type == 'T' ) THEN
-         DO jk = 1, jpk           
-            DO ji = nistr, niend, nn_factx
-               DO jj   = njstr, njend, nn_facty
-                  ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
-                  ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-                  ijje = mje_crs(ij)
-                  ijie = mie_crs(ii)
-                  !
-                  zdAm =  zvol(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk)  &
-                    &   + zvol(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk)  &
-                    &   + zvol(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk)  &
-                    &   + zvol(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk)  &
-                    &   + zvol(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk)  &
-                    &   + zvol(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk)  &
-                    &   + zvol(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk)  &
-                    &   + zvol(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk)  &
-                    &   + zvol(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk)
-                    ! 
-                   IF( p_fld1_crs(ii,ij,jk) /= 0._wp ) p_fld2_crs(ii,ij,jk) = zdAm / p_fld1_crs(ii,ij,jk) 
-                   ! 
-               ENDDO
-            ENDDO
-         ENDDO
-      ENDIF
-      !
-      IF( cd_type == 'W' ) THEN
-         DO jk = 2, jpk           
-            DO ji = nistr, niend, nn_factx
-               DO jj   = njstr, njend, nn_facty
-                  ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
-                  ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-                  ijje = mje_crs(ij)
-                  ijie = mie_crs(ii)
-                  !
-                  zdAm =  zvol(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk-1)  &
-                    &   + zvol(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk-1)  &
-                    &   + zvol(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk-1)  &
-                    &   + zvol(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk-1)  &
-                    &   + zvol(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk-1)  &
-                    &   + zvol(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk-1)  &
-                    &   + zvol(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk-1)  &
-                    &   + zvol(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk-1)  &
-                    &   + zvol(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk-1)
-                  !
-                  IF( p_fld1_crs(ii,ij,jk) /= 0._wp ) p_fld2_crs(ii,ij,jk) = zdAm / p_fld1_crs(ii,ij,jk) 
-                  !
-               ENDDO
-            ENDDO
-         ENDDO
-         DO ji = nistr, niend, nn_factx
-            DO jj   = njstr, njend, nn_facty
-               ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
-               ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-               ijje = mje_crs(ij)
-               ijie = mie_crs(ii)
-               !
-               zdAm =  zvol(ji  ,jj  ,1) * p_mask(ji  ,jj  ,1)  &
-                 &   + zvol(ji+1,jj  ,1) * p_mask(ji+1,jj  ,1)  &
-                 &   + zvol(ji+2,jj  ,1) * p_mask(ji+2,jj  ,1)  &
-                 &   + zvol(ji  ,jj+1,1) * p_mask(ji  ,jj+1,1)  &
-                 &   + zvol(ji+1,jj+1,1) * p_mask(ji+1,jj+1,1)  &
-                 &   + zvol(ji+2,jj+1,1) * p_mask(ji+2,jj+1,1)  &
-                 &   + zvol(ji  ,jj+2,1) * p_mask(ji  ,jj+2,1)  &
-                 &   + zvol(ji+1,jj+2,1) * p_mask(ji+1,jj+2,1)  &
-                 &   + zvol(ji+2,jj+2,1) * p_mask(ji+2,jj+2,1)
-               ! 
-               IF( p_fld1_crs(ii,ij,1) /= 0._wp ) p_fld2_crs(ii,ij,1) = zdAm / p_fld2_crs(ii,ij,1) 
-               ! 
-            ENDDO
-         ENDDO
-      ENDIF
-      
       !                                             !  Retroactively add back the boundary halo cells.
       CALL crs_lbc_lnk( p_fld1_crs, cd_type, 1.0 ) 
       CALL crs_lbc_lnk( p_fld2_crs, cd_type, 1.0 ) 
       !
-      CALL wrk_dealloc( jpi, jpj, jpk, zvol )
+      CALL wrk_dealloc( jpi, jpj, jpk, zvol, zmask )
       !
    END SUBROUTINE crs_dom_facvol
 
 
-   SUBROUTINE crs_dom_ope_3d( p_fld, cd_op, cd_type, p_mask, p_fld_crs, p_e12, p_e3, p_surf_crs, p_mask_crs )
+   SUBROUTINE crs_dom_ope_3d( p_fld, cd_op, cd_type, p_mask, p_fld_crs, p_e12, p_e3, p_surf_crs, p_mask_crs, psgn )
       !!----------------------------------------------------------------
       !!               *** SUBROUTINE crsfun_UV ***
@@ -476,17 +485,18 @@
       REAL(wp), DIMENSION(jpi,jpj,jpk),         INTENT(in), OPTIONAL :: p_e3     ! Parent grid vertical level thickness (fse3u, fse3v)
       REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(in), OPTIONAL :: p_surf_crs ! Coarse grid area-weighting denominator    
-      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(in), OPTIONAL :: p_mask_crs    ! Coarse grid T,U,V mask
+      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(in), OPTIONAL :: p_mask_crs    ! Coarse grid T,U,V maska
+      REAL(wp),                                 INTENT(in)           :: psgn    ! sign 
+
 
       REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(out)          :: p_fld_crs ! Coarse grid box 3D quantity 
 
       !! Local variables
-      INTEGER  :: ji, jj, jk                 ! dummy loop indices
-      INTEGER  :: ijie, ijje, ii, ij
+      INTEGER  :: ji, jj, jk 
+      INTEGER  :: ii, ij, ijie, ijje, je_2
       REAL(wp) :: zflcrs, zsfcrs   
-      REAL(wp) :: zeps = 1.e20    
-      REAL(wp), DIMENSION(:,:,:), POINTER :: zsurf   
-
+      REAL(wp), DIMENSION(:,:,:), POINTER :: zsurf, zsurfmsk, zmask  
       !!----------------------------------------------------------------  
    
+      p_fld_crs(:,:,:) = 0.0
 
       SELECT CASE ( cd_op )
